/*
However there is a useful c function called dtostrf() which will convert a float to a char array so it can then be printed easily

The format is:  dtostrf(floatvar, StringLengthIncDecimalPoint, numVarsAfterDecimal, charbuf);

where
floatvar                        float variable
StringLengthIncDecimalPoint     This is the length of the string that will be created
numVarsAfterDecimal             The number of digits after the deimal point to print
charbuf                         the array to store the results
*/

//GLCD fonts - part of GLCD lib
#include "utility/font_helvB14.h" 	             //big numberical digits 
#include "utility/font_clR6x8.h" 	               //title
#include "utility/font_clR4x6.h" 	               //kwh

float cval, cval2, cval3, cval4;                 //values to calulate smoothing

void draw_main_screen()
{
  glcd.clear();
  glcd.fillRect(0,0,128,64,0);
  
  glcd.drawLine(64, 0, 64, 64, WHITE);           //top vertical line
  glcd.drawLine(0, 32, 128, 32, WHITE);          //middle horizontal line
                
  char str[50];    			                         //array to store conversion up to 50 char (0 to 49) + 'null' char
  
  glcd.setFont(font_clR6x8);             
  glcd.drawString_P(5,0,PSTR("Using W"));        //2,0 = x,y position on screen
  glcd.drawString_P(72,0,PSTR("Solar W"));       //2,0 = x,y position on screen
  glcd.drawString_P(70,33,PSTR("Room Temp"));    //2,0 = x,y position on screen
   
  if (importing==1)
   {
     glcd.drawString_P(5,34,PSTR("Import W"));   //2,0 = x,y position on screen
   }
   else
   {
     glcd.drawString_P(5,34,PSTR("Export W"));   //2,0 = x,y position on screen
   }
    
  glcd.setFont(font_helvB14);  		               //big bold font used for printout


//itoa = integer to array
//itoa ( int value, str, int base )
//int value               Value to be converted to a string.
//str                     Array in memory where to store the resulting null-terminated string.
//base                    Numerical base used to represent the value as a string, between 2 and 36
//                        where 10 means decimal base, 16 hexadecimal, 8 octal, and 2 binary.

  cval = cval + (consuming - cval)*0.50;         //new value of cval = previous value of cval + 1/2 of (consuming - cval)
  itoa((int)cval,str,10);                        //(int)cval resets string to empty?
  //strcat(str,"w");                             //string cocantination, adds strings together (value of 'str'+"w")
  glcd.drawString(5,9,str);                      //printout of power currently being used by whole house (Using)
               
  cval2 = cval2 + (gen - cval2)*0.5;             //cval used in 'smoothing' calcs
  itoa((int)cval2,str,10);                       //(int)cval2 resets string to empty?
  //strcat(str,"w");                             //string cocantination, adds strings together (value of 'str'+"w") 
  glcd.drawString(74,9,str);                     //printout of power currently being generated (Solar)
               
  cval3 = cval3 + (grid - cval3)*0.5;
  itoa((int)cval3,str,10);                       //(int)cval3 resets string to empty?
  //strcat(str,"w");                             //string cocantination, adds strings together (value of 'str'+"w")  
  glcd.drawString(5,42,str);                     //printout of power currently being imported/exported
                
  dtostrf(temp,0,1,str); 
  strcat(str,"C");                               //string cocantination, adds strings together (value of 'str'+"C")
  glcd.drawString(70,42,str);   
               
  glcd.setFont(font_clR4x6);                     //small font printout
  dtostrf((wh_consuming/1000),0,1,str);
  strcat(str,"kWh today");                       //string cocantination, adds strings together (value of 'str'+"kWh today")
  glcd.drawString(6,26,str);
               
  dtostrf((wh_gen/1000),0,1,str); 
  strcat(str,"kWh today");                       //string cocantination, adds strings together (value of 'str'+"kWh today")
  glcd.drawString(71,26,str);

  dtostrf((wh_grid/1000),0,1,str); 
  strcat(str,"kWh today");                       //string cocantination, adds strings together (value of 'str'+"kWh today")
  glcd.drawString(6,58,str);

/*                             
  itoa((int)mintemp,str,10);
  strcat(str,"C");                               //string cocantination, adds strings together
  glcd.drawString_P(68,58,PSTR("min"));
  glcd.drawString(82,58,str);
               
  itoa((int)maxtemp,str,10); 
  strcat(str,"C");                               //string cocantination, adds strings together
  glcd.drawString_P(97,58,PSTR("max"));
  glcd.drawString(111,58,str);
*/
  

  if (((millis()-last_emontx)<60000) && ((millis()-last_emonbase)<60000))
  {
   glcd.drawString_P(70,58,PSTR("Time:"));                   //2,0 = x,y position on screen
   writeTime(str);
   glcd.drawString(94,58,str); 
  }
   else
  
    if ((millis()-last_emontx)>60000)
     { 
      glcd.drawString_P(70,58,PSTR("emonTx fail"));          //2,0 = x,y position on screen
     }
      else
     {
      glcd.drawString_P(58,58,PSTR("emonBase fail"));        //2,0 = x,y position on screen
     }

  glcd.refresh();
                    
}

void draw_page_two()
{
  glcd.clear;
  glcd.fillRect(0,0,128,64,0);
  
  glcd.setFont(font_clR6x8);                                                //medium font printout
  glcd.drawString_P(2,0,PSTR("Current Time:"));
               
  DateTime now = RTC.now();
  char str[20];
  writeTime(str);           
  glcd.setFont(font_helvB14);  		//big bold font   
  glcd.drawString(2,10,str);

  glcd.setFont(font_clR4x6);                                                //small font printout
  glcd.drawString_P(2,50,PSTR("My_emonGLCD_17-3-2019_1"));

  glcd.refresh();
  
  delay(2000); 
  
}

/*
void backlight_control()
{
   int LDR = analogRead(LDRpin);                    // Read the LDR Value so we can work out the light level in the room.                    
   int LDRbacklight = map(LDR, 0, 1023, 50, 250);    // Map the data from the LDR from 0-1023 (Max seen 1000) to var GLCDbrightness min/max
   LDRbacklight = constrain(LDRbacklight, 0, 255);   // Constrain the value to make sure its a PWM value 0-255
                                                 
  //--------------------------------------------------------------------
  // Turn off backlight and indicator LED's between 11pm and 6am
  //-------------------------------------------------------------------- 
  
  DateTime now = RTC.now();
  if (now.hour()>0) int hour = now.hour();                    //get hour digit in 24hr from software RTC
 
  if ((hour > 22) ||  (hour < 5) && ((millis()-last_emonbase)<60000))       // turn off backlight between 11pm and 6am
   {
    night=1; 
    glcd.backLight(0);
   } 
   else
   {
    night=0; 
    glcd.backLight(LDRbacklight);  
   }
}
*/

//--------------------------------------------------------------------
//Change color of LED on top of emonGLCD, red if consumption exceeds gen or green if gen is greater than consumption 
//-------------------------------------------------------------------- 
void led_control()
{
//--------------------------------------------------------------------
//Change color of LED on top of emonGLCD, red if consumption exceeds gen or green if gen is greater than consumption 
//-------------------------------------------------------------------- 
   int PWRleds= map(cval3, 0, 4000, 0, 255);     // Map importing value from 0-4Kw (LED brightness -- cval3 is the smoothed grid value - see display above 
   PWRleds = constrain(PWRleds, 0, 255);         // Constrain the value to make sure its a PWM value 0-255
   
    if ((gen>0) && (night==0)) 
    {
      if (cval2 > cval)
      {                                          //show green LED when gen>consumption cval are the smooth curve values  
	     analogWrite(redLED, 0);         
	     analogWrite(greenLED, PWRleds);    
      } 
      else                                       //red if consumption>gen
      {
       analogWrite(greenLED, 0);  
	     analogWrite(redLED, PWRleds);   
      }
    } 
    else                                     //Led's off at night and when solar PV is not generating
    {
     analogWrite(redLED, 0);
     analogWrite(greenLED, 0);
    }
}

void writeTime(char *str)
{
  DateTime now = RTC.now();
  char str2[3];
  if (now.hour()<10)
  {
	str[0]='0';
	itoa(now.hour(),str+1,10);
  }
  else
    itoa(now.hour(),str,10);
  if  (now.minute()<10) 
	strcat(str,":0"); 
  else 
	strcat(str,":"); 
  itoa(now.minute(),str2,10);
  strcat(str,str2); 
}
